

#define	VER			"1.3"		// Wersja softu


#define		DMXDIMMER	0			// sterownik przekanika i ciemiacza -  8MHz
#define		DMXRGB		1			// sterownik RGB (zajmuje 3 adresy)   -  8MHz
#define		SERVO		2			// sterownik serw (zajmuje 4 adresy)  - 16MHz
#define		DEMUX		3			// demultiplekser (zajmuje 4 adresy)  - 16MHz
//
#define		DEVICE		DMXRGB		// Typ urzdzenia


//#define	LEDSTTEST				// Gdy zdefiniowane to led st pokazuje czas obslugi IRQ UARTa





/********************************************************************************/
#if DEVICE==DMXDIMMER && F_CPU != 8000000
  #error "Zly F_CLK dla ego urzadzenia"
#endif

#if DEVICE==DMXRGB && F_CPU != 8000000
  #error "Zly F_CLK dla ego urzadzenia"
#endif

#if DEVICE==SERVO && F_CPU != 16000000
  #error "Zly F_CLK dla ego urzadzenia"
#endif

#if DEVICE==DEMUX && F_CPU != 16000000
  #error "Zly F_CLK dla ego urzadzenia"
#endif


/********************************************************************************/
/*																				*/
/********************************************************************************/
#define	uchar	unsigned char
#define	byte	unsigned char
#define	uint	unsigned int
#define	word	unsigned int
#define	ulong	unsigned long
#define	dword	unsigned long
#define	FALSE	0
#define	TRUE	1
#define	false	FALSE
#define	true	TRUE
#define	False	FALSE
#define	True	TRUE


#define	NONE		-1
#define	PARITYERR	-2
#define	FRAMEERR	-3
#define	OVERRUNERR	-4

#define	CRLF	"\r\n"
#define	CR		'\r'
#define	LF		'\n'
#define	ESC		0x2B
#define	EXIT	ESC


#define	CNT0_PRESCALER_0		0
#define	CNT0_PRESCALER_1		1
#define	CNT0_PRESCALER_8		2
#define	CNT0_PRESCALER_64		3
#define	CNT0_PRESCALER_256		4
#define	CNT0_PRESCALER_1024		5
#define	CNT0_PRESCALER_T0faling	6
#define	CNT0_PRESCALER_T0rising	7

#define	CNT1_PRESCALER_0		0
#define	CNT1_PRESCALER_1		1
#define	CNT1_PRESCALER_8		2
#define	CNT1_PRESCALER_64		3
#define	CNT1_PRESCALER_256		4
#define	CNT1_PRESCALER_1024		5
#define	CNT1_PRESCALER_T1faling	6
#define	CNT1_PRESCALER_T1rising	7

#define	CNT2_PRESCALER_0		0
#define	CNT2_PRESCALER_1		1
#define	CNT2_PRESCALER_8		2
#define	CNT2_PRESCALER_32		3
#define	CNT2_PRESCALER_64		4
#define	CNT2_PRESCALER_128		5
#define	CNT2_PRESCALER_256		6
#define	CNT2_PRESCALER_1024		7



#include <avr/io.h>									// IO
#include <stdio.h>									//
#include <stdlib.h>									//
#include <avr/sfr_defs.h>							// SFR, _BV(bit)
#include <avr/pgmspace.h>							// Flash
#define  CODE PROGMEM
#include <avr/interrupt.h>							// wektory IRQ
#include <avr/wdt.h> 								// WDG
#include <avr/eeprom.h>								// Eeprom
#include <string.h>									// Stringi
#include <compat/deprecated.h>						// sbi, cbi, inb, outb, outp
#define  ebi(port,bit) ( port ^= (1 << (bit)))		// Negowanie bitu na porcie
#define	BAUD	250000
#include <util/setbaud.h>							// Uart 0
//#define	BAUD1	9600
//#include "include/setbaud1.h"						// Uart 1
#include <util/delay.h>
#include <util/crc16.h>								// Crc16, Xmodem, Dallas
#include <avr/fuse.h>
#define NOINIT __attribute__ ((section(".noinit")))
#define nop()	__asm__ __volatile__( "nop" )		// Wstawia rozkaz NOP do kodu
#include <avr/sleep.h>								// Tryby upienia
#include <avr/power.h>								// Wyaczanie peryferii



//---------------------------------------------------------------------------------------
/*
// Interrupt Vectors
// Interrupt Vector 0 is the reset vector.
#define INT0_vect         _VECTOR(1)   // External Interrupt Request 0
#define INT1_vect         _VECTOR(2)   // External Interrupt Request 1
#define PCINT0_vect       _VECTOR(3)   // Pin Change Interrupt Request 0
#define PCINT1_vect       _VECTOR(4)   // Pin Change Interrupt Request 0
#define PCINT2_vect       _VECTOR(5)   // Pin Change Interrupt Request 1
#define WDT_vect          _VECTOR(6)   // Watchdog Time-out Interrupt
#define TIMER2_COMPA_vect _VECTOR(7)   // Timer/Counter2 Compare Match A
#define TIMER2_COMPB_vect _VECTOR(8)   // Timer/Counter2 Compare Match A
#define TIMER2_OVF_vect   _VECTOR(9)   // Timer/Counter2 Overflow
#define TIMER1_CAPT_vect  _VECTOR(10)  // Timer/Counter1 Capture Event
#define TIMER1_COMPA_vect _VECTOR(11)  // Timer/Counter1 Compare Match A
#define TIMER1_COMPB_vect _VECTOR(12)  // Timer/Counter1 Compare Match B
#define TIMER1_OVF_vect   _VECTOR(13)  // Timer/Counter1 Overflow
#define TIMER0_COMPA_vect _VECTOR(14)  // TimerCounter0 Compare Match A
#define TIMER0_COMPB_vect _VECTOR(15)  // TimerCounter0 Compare Match B
#define TIMER0_OVF_vect   _VECTOR(16)  // Timer/Couner0 Overflow
#define SPI_STC_vect      _VECTOR(17)  // SPI Serial Transfer Complete
#define USART_RX_vect     _VECTOR(18)  // USART Rx Complete
#define USART_UDRE_vect   _VECTOR(19)  // USART, Data Register Empty
#define USART_TX_vect     _VECTOR(20)  // USART Tx Complete
#define ADC_vect          _VECTOR(21)  // ADC Conversion Complete
#define EE_READY_vect     _VECTOR(22)  // EEPROM Ready
#define ANALOG_COMP_vect  _VECTOR(23)  // Analog Comparator
#define TWI_vect          _VECTOR(24)  // Two-wire Serial Interface
#define SPM_READY_vect    _VECTOR(25)  // Store Program Memory Read

void* tim_handler;
ISR(TIMER2_COMP_vect,ISR_NAKED)
{
asm("ijmp"::"z"(tim_handler));
}

Skoro "program gwny" nic nie robi to przerwanie nigdy nie moe zepsu jego stanu, a wic nie ma powodu eby obsuga przerwan zapisywaa rejestry czy cokolwiek - dlatego ISR_NAKED.


*/



//---------------------------------------------------------------------------------------
void InitTimer0();
void InitTimer2();
byte volatile TCNT0_HH=0;
void InitTimer1();
void InitInt0();
void InitInt1();
#define	RdDmxIn()	(PIND & (1 << PD0))


#define	DdrA0()		PORTC |=(1<<PC5)			// Wlacz podciaganie
#define	RdA0()		(PINC & (1<<PC5))
#define	DdrA1()		PORTC |=(1<<PC4)
#define	RdA1()		(PINC & (1<<PC4))
#define	DdrA2()		PORTC |=(1<<PC3)
#define	RdA2()		(PINC & (1<<PC3))
#define	DdrA3()		PORTC |=(1<<PC2)
#define	RdA3()		(PINC & (1<<PC2))
#define	DdrA4()		PORTC |=(1<<PC1)
#define	RdA4()		(PINC & (1<<PC1))
#define	DdrA5()		PORTC |=(1<<PC0)
#define	RdA5()		(PINC & (1<<PC0))
#define	DdrA6()		PORTD |=(1<<PD4)
#define	RdA6()		(PIND & (1<<PD4))
#define	DdrA7()		PORTD |=(1<<PD5)
#define	RdA7()		(PIND & (1<<PD5))
#define	DdrA8()		PORTD |=(1<<PD6)
#define	RdA8()		(PIND & (1<<PD6))


//----- Zworka zalozona to przy braku transmiji wyjscia wylaczane, brak zworki: wyjscie pamieta ostatni stan
#define	DdrCfg0()	PORTB |=(1<<PB0)			// Wlacz podciaganie
#define	RdCfg0()	(PINB & (1<<PB0))

//----- Zworka zalozona to pojedyncza transmisja jest akceptowana, brak zworki: to dwie identyczne transmisje zmienia stan wyjscia
#define	DdrCfg1()	PORTD |=(1<<PD1)			// Wlacz podciaganie
#define	RdCfg1()	(PIND & (1<<PD1))

#define	DdrCfg2()	PORTD |=(1<<PD2)			// Wlacz podciaganie
#define	RdCfg2()	(PIND & (1<<PD2))			// NIE UZYWANE

#if DEVICE==DMXDIMMER
 #define	DdrInt1()	PORTD |=(1<<PD3)		// Wlacz podciaganie dla CNY
#endif											// Dla INT1 (aktualnie Cfg2) nie uzywamy pociagania (rezystor szeregowy jak w dekodarze DCC)


enum {DEV_PK, DEV_DIMMER };
enum {DMX_OFFLINE, DMX_BREAK, DMX_MAB, DMX_READ };
word CntDanych = 0;
byte DmxStatus = DMX_OFFLINE;
byte StInDmx = 0;


#if DEVICE==DMXDIMMER
 byte RejestrPWM = 0, RejestrPWMirq = 0;
#endif


word ReadAdrDMX();
word AdrDMX=0;


#if DEVICE==DMXDIMMER
 #define	PxPWM		PB2
 #define	DdrPWM()	DDRB  |=  (1<<PxPWM)
 #define	SetPWM()	PORTB &= ~(1<<PxPWM)
 #define	ClrPWM()	PORTB |=  (1<<PxPWM)
#elif DEVICE==DMXRGB || DEVICE==DEMUX
 #define	PxPWMr		PB1
 #define	PxPWMg		PB2
 #define	PxPWMb		PD3
 #define	PxPWMw		PB3
 #define	DdrPWM()	DDRB  |=  (1<<PxPWMr); DDRB  |=  (1<<PxPWMg); DDRB  |=  (1<<PxPWMw); DDRD  |=  (1<<PxPWMb)
#elif DEVICE==SERVO
 #define	S1			PB2
 #define	DdrS1()		DDRB  |=  (1<<S1)
 #define	SetS1()		PORTB |=  (1<<S1)
 #define	ClrS1()		PORTB &= ~(1<<S1)

 #define	S2			PB1
 #define	DdrS2()		DDRB  |=  (1<<S2)
 #define	SetS2()		PORTB |=  (1<<S2)
 #define	ClrS2()		PORTB &= ~(1<<S2)

 #define	S3			PD2
 #define	DdrS3()		DDRD  |=  (1<<S3)
 #define	SetS3()		PORTD |=  (1<<S3)
 #define	ClrS3()		PORTD &= ~(1<<S3)

 #define	S4			PD3
 #define	DdrS4()		DDRD  |=  (1<<S4)
 #define	SetS4()		PORTD |=  (1<<S4)
 #define	ClrS4()		PORTD &= ~(1<<S4)
#endif


#if DEVICE==DMXDIMMER
 #define	PxPK		PB1
 #define	DdrPK()		DDRB  |=  (1<<PxPK)
 #define	SetPK()		PORTB |=  (1<<PxPK)
 #define	ClrPK()		PORTB &= ~(1<<PxPK)
 #define	HISTEREZAPK	10
#endif



/*#if DEVICE==DEMUX				// cos sie pieprzy przy kompilacji

 #define	PxLedDmx		PD2
 #define	DdrLedDmxO()	DDRD  |=  (1<<PxLedDmx)
 #define	SetLedDmx()		PORTD &= ~(1<<PxLedDmx)
 #define	ClrLedDmx()		PORTD |=  (1<<PxLedDmx)
 #define	EorLedDmx()		PORTD ^=  (1<<PxLedDmx)
#elif
*/
 #define	PxLedDmx		PB3
 #define	DdrLedDmxO()	DDRB  |=  (1<<PxLedDmx)
 #define	DdrLedDmxI()	DDRB  &= ~(1<<PxLedDmx); PORTB |=  (1<<PxLedDmx)		// Wejcie z podciaganiem
 #define	SetLedDmx()		PORTB &= ~(1<<PxLedDmx)
 #define	ClrLedDmx()		PORTB |=  (1<<PxLedDmx)
 #define	EorLedDmx()		PORTB ^=  (1<<PxLedDmx)
 #define	RdLedDmx()		(PORTB & (1<<PxLedDmx))		// Odczyt stanu diody LED
 #define	RdPinDmx()		(PINB & (1<<PxLedDmx))		// Odczyt piny diody LED
//#endif


#define	PxLedST			PD7
#define	DdrLedST()		DDRD  |=  (1<<PxLedST)
#define	SetLedST()		DDRD  |=  (1<<PxLedST); PORTD &= ~(1<<PxLedST)		// Pozim niski na wyjcu
#define	ClrLedST()		DDRD  &= ~(1<<PxLedST); 							// Wyjcie w stanie trzecim lub wysokim
#define	EorLedST()		PORTD ^=  (1<<PxLedST)


void InitUart();
byte UsartStatus, UsartDana;
#define	MIN_DMX_OFLINE	1			// Czas braku transmisji w sekundach, uznany jako brak sygnalu DMX


void SaveCfg();


enum{SIN_H_TRIAK_OFF, SIN_H_TRIAK_ON, SIN_L_TRIAK_OFF, SIN_L_TRIAK_ON,};
#if DEVICE==DMXDIMMER
 byte fazaPWM = SIN_H_TRIAK_OFF;
 void SetNewValuePwm( byte input );
#endif


#if DEVICE==DMXDIMMER
 #define	RdInInt0()	(PIND & (1<<PD2))
 #define	RdInInt1()	(PIND & (1<<PD3))
#endif


#if DEVICE==SERVO
 byte TabServ[4] = {128, 128, 128, 128};
 byte EETabServ[4] EEMEM = {128, 128, 128, 128};
#endif



void DemoRGB();
#define	PWMRED		OCR1B
#define	PWMGREEN	OCR1A
#define	PWMBLUE		OCR2B

// ------ gamma = 2,5
byte gamma32_correction[] PROGMEM = {
  0,  1,  1,  1,  2,  3,  5,  7, 10, 13, 17, 21, 26, 32, 38, 45, 52, 60,
 69, 78, 88, 99,111,124,137,151,166,182,199,217,235,255
};


byte gamma256_correction[] PROGMEM = {
0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,				// Tu byly tylko zera
1,1,1,1,1,1,1,2,2,2,2,2,3,3,3,3,4,4,		// Od tad pojawila sie jedynka
4,4,5,5,5,5,6,6,6,7,7,7,8,8,9,9,
9,10,10,10,11,11,12,12,13,13,14,
14,15,15,16,16,17,17,18,18,19,19,20,20,21,21,22,
23,23,24,25,25,26,26,27,28,28,29,30,30,31,32,33,
33,34,35,36,36,37,38,39,39,40,41,42,43,43,44,45,46,
47,48,49,49,50,51,52,53,54,55,56,57,58,59,60,61,
62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,
78,79,81,82,83,84,85,86,87,89,90,91,92,93,95,96,
97,98,100,101,102,103,105,106,
107,108,110,111,112,114,115,116,
118,119,121,122,123,125,126,127,
129,130,132,133,135,136,138,139,
141,142,144,145,147,148,150,151,
153,154,156,157,159,160,162,164,
165,167,169,170,172,173,175,177,
178,180,182,183,185,187,189,190,
192,194,196,197,199,201,203,204,
206,208,210,212,213,215,217,219,
221,223,225,226,228,230,232,234,
236,238,240,242,244,246,248,250,
252,255,255
};



//**********************************************************************//
//						Bity konfiguracyjne		 						//
//**********************************************************************//

__fuse_t __fuse __attribute__((section (".fuse"))) =
#if defined(__AVR_ATmega88__) || defined(__AVR_ATmega88P__) || defined(__AVR_ATmega168__) || defined(__AVR_ATmega168P__)
{
	.extended	= 0xF9,
	.high		= 0xCC,
	.low		= 0xFF,
};
#else
	#error "NIEZNANY TYP PROCESORA w ustawieniu bitow konfiguracyjnych"
#endif


/*
__attribute__((section (".lock"))) const unsigned char __lock =
0xFC;
*/



//**********************************************************************//
//						Program glowny			 						//
//**********************************************************************//
int main()
{


	InitTimer0();
	InitTimer1();
	InitTimer2();

	#if DEVICE==DMXDIMMER
//	 InitInt0();				// Sync z rezystora
	 InitInt1();				// Sync z transoptora
	 DdrPK(); ClrPK();
	#elif DEVICE==DMXRGB || DEVICE==DEMUX
	 DdrPWM();
	#elif DEVICE==SERVO
	 DdrS1(); DdrS2(); DdrS3(); DdrS4();
	#endif



	DdrLedDmxO();
	ClrLedDmx(); ClrLedST();
	InitUart();


	DdrA0(); DdrA1(); DdrA2(); DdrA3(); DdrA4(); DdrA5(); DdrA6(); DdrA7(); DdrA8();
	DdrCfg0(); DdrCfg1(); DdrCfg2();

	#if DEVICE==DMXDIMMER
	 DdrInt1();
	#endif

	//--- init WDG ---
	//WDTO_15MS
	//WDTO_30MS
	//WDTO_60MS
	//WDTO_120MS
	//WDTO_250MS
	//WDTO_500MS
	//WDTO_1S
	//WDTO_2S
	#define	WDTO_TIME	WDTO_120MS
	wdt_enable( WDTO_TIME );						// Blokuje IRQ !!!


	AdrDMX = ReadAdrDMX();							// odczytaj adres DMX z DIP-switch


	#if DEVICE==SERVO
	eeprom_read_block (&TabServ, &EETabServ, sizeof(TabServ));	// Odczyt eeprom
  //eeprom_read_block (void *__dst, const void *__src, size_t __n);
	#endif


	sei();


	//-----------------------------------------------------------------------------------
	//								Petla glowna
	//-----------------------------------------------------------------------------------
	while( 1 )
		{
		wdt_reset();


		AdrDMX = ReadAdrDMX();				// odczytaj adres DMX z DIP-switch


		#if DEVICE==DMXRGB
		 if ( !RdCfg2() && DmxStatus==DMX_OFFLINE )
		 	{
			DemoRGB();
			}
		#endif


		if ( DmxStatus == DMX_OFFLINE )		// Obsluga diody led
			{
			ClrLedDmx();
			#ifndef LEDSTTEST
			 ClrLedST();
			#endif
			}
		else
			{
			DdrLedST();
			SetLedDmx();
			SaveCfg();						// Zapis ustawie serw gdy zaoona zwork
			}
		}
}



/*************************************************************************/
/*							Funkcje										 */
/*************************************************************************/



//-------------------------------------------------------------------------
//					Zapis polozenia serw
//-------------------------------------------------------------------------
void DemoRGB()
{
#define	RGBoff()	DemoRED=0; DemoGREEN=0; DemoBLUE=0;

static byte StDemoRBG=16, DemoRED, DemoGREEN, DemoBLUE;
static word TimerRGB=0;


	_delay_us(1);

	if ( --TimerRGB ) { return; }
	TimerRGB = 400;						// Okoo sekundy


	switch( StDemoRBG )
		{
		case 0:
				PWMRED = pgm_read_byte(&gamma256_correction[ DemoRED++ ]); 
				if ( DemoRED == 255 ) { StDemoRBG++; }
				break;
		case 1:
				PWMRED = pgm_read_byte(&gamma256_correction[ DemoRED-- ]); 
				if ( ! DemoRED ) { StDemoRBG++; }
				break;
		case 2:
				PWMGREEN = pgm_read_byte(&gamma256_correction[ DemoGREEN++ ]); 
				if ( DemoGREEN == 255 ) { StDemoRBG++; }
				break;
		case 3:
				PWMGREEN = pgm_read_byte(&gamma256_correction[ DemoGREEN-- ]); 
				if ( ! DemoGREEN ) { StDemoRBG++; }
				break;
		case 4:
				PWMBLUE = pgm_read_byte(&gamma256_correction[ DemoBLUE++ ]); 
				if ( DemoBLUE == 255 ) { StDemoRBG++; }
				break;
		case 5:
				PWMBLUE = pgm_read_byte(&gamma256_correction[ DemoBLUE-- ]); 
				if ( ! DemoBLUE ) { StDemoRBG++; RGBoff(); }
				break;


		//----//
		case 6:
				PWMRED = pgm_read_byte(&gamma256_correction[ DemoRED++ ]); 
				PWMBLUE = pgm_read_byte(&gamma256_correction[ DemoBLUE++ ]); 
				if ( DemoRED == 255 ) { StDemoRBG++; }
				break;
		case 7:
				PWMRED = pgm_read_byte(&gamma256_correction[ DemoRED-- ]); 
				PWMBLUE = pgm_read_byte(&gamma256_correction[ DemoBLUE-- ]); 
				if ( ! DemoRED ) { StDemoRBG++; RGBoff(); }
				break;


		//----//
		case 8:
				PWMBLUE = pgm_read_byte(&gamma256_correction[ DemoBLUE++ ]); 
				if ( DemoBLUE == 255 ) { StDemoRBG++; }
				break;
		case 9:
				PWMRED = pgm_read_byte(&gamma256_correction[ DemoRED++ ]); 
				PWMBLUE = pgm_read_byte(&gamma256_correction[ DemoBLUE-- ]); 
				if ( DemoRED == 255 ) { StDemoRBG++; }
				break;
		case 10:
				PWMRED = pgm_read_byte(&gamma256_correction[ DemoRED-- ]); 
				PWMBLUE = pgm_read_byte(&gamma256_correction[ DemoBLUE++ ]); 
				if ( DemoBLUE == 255 ) { StDemoRBG++; }
				break;
		case 11:
				PWMBLUE = pgm_read_byte(&gamma256_correction[ DemoBLUE-- ]); 
				if ( ! DemoBLUE ) { StDemoRBG++; RGBoff(); }
				break;


		//----//
		case 12:
				PWMGREEN = pgm_read_byte(&gamma256_correction[ DemoGREEN++ ]); 
				if ( DemoGREEN == 255 ) { StDemoRBG++; }
				break;
		case 13:
				PWMRED = pgm_read_byte(&gamma256_correction[ DemoRED++ ]); 
				PWMGREEN = pgm_read_byte(&gamma256_correction[ DemoGREEN-- ]); 
				if ( DemoRED == 255 ) { StDemoRBG++; }
				break;
		case 14:
				PWMRED = pgm_read_byte(&gamma256_correction[ DemoRED-- ]); 
				PWMGREEN = pgm_read_byte(&gamma256_correction[ DemoGREEN++ ]); 
				if ( DemoGREEN == 255 ) { StDemoRBG++; }
				break;
		case 15:
				PWMGREEN = pgm_read_byte(&gamma256_correction[ DemoGREEN-- ]); 
				if ( ! DemoGREEN ) { StDemoRBG++; RGBoff(); }
				break;



		//----//
		case 16:
				PWMRED = pgm_read_byte(&gamma256_correction[ DemoRED++ ]); 
				PWMGREEN = pgm_read_byte(&gamma256_correction[ DemoGREEN++ ]); 
				if ( DemoRED == 255 ) { StDemoRBG++; }
				break;
		case 17:
				PWMRED = pgm_read_byte(&gamma256_correction[ DemoRED-- ]); 
				PWMGREEN = pgm_read_byte(&gamma256_correction[ DemoGREEN-- ]); 
				if ( ! DemoRED ) { StDemoRBG++; RGBoff(); }
				break;
		//----//
		case 18:
				PWMBLUE = pgm_read_byte(&gamma256_correction[ DemoBLUE++ ]); 
				PWMGREEN = pgm_read_byte(&gamma256_correction[ DemoGREEN++ ]); 
				if ( DemoBLUE == 255 ) { StDemoRBG++; }
				break;
		case 19:
				PWMBLUE = pgm_read_byte(&gamma256_correction[ DemoBLUE-- ]); 
				PWMGREEN = pgm_read_byte(&gamma256_correction[ DemoGREEN-- ]); 
				if ( ! DemoBLUE ) { StDemoRBG++; RGBoff(); }
				break;
/*		//----//
		case 20:
				PWMBLUE = pgm_read_byte(&gamma256_correction[ DemoBLUE++ ]); 
				PWMGREEN = pgm_read_byte(&gamma256_correction[ DemoGREEN++ ]); 
				PWMBLUE = pgm_read_byte(&gamma256_correction[ DemoBLUE++ ]); 
				if ( DemoBLUE == 255 ) { StDemoRBG++; }
				break;
		case 21:
				PWMBLUE = pgm_read_byte(&gamma256_correction[ DemoBLUE-- ]); 
				PWMGREEN = pgm_read_byte(&gamma256_correction[ DemoGREEN-- ]); 
				PWMBLUE = pgm_read_byte(&gamma256_correction[ DemoBLUE-- ]); 
				if ( ! DemoBLUE ) { StDemoRBG++; RGBoff();}
				break;

*/

		default: 
				StDemoRBG = 0;
				RGBoff();
		}


}



//-------------------------------------------------------------------------
//					Zapis polozenia serw
//-------------------------------------------------------------------------
void SaveCfg()
{
#if DEVICE==SERVO
byte stan, cSREG;
static byte cnt=0;


	stan = RdLedDmx();			// Odczyt stanu diody LED
	DdrLedDmxI();				// Port wejciem


	if ( !RdPinDmx() )				// Czy wykryto zwork
		{
		cnt++;
		}
	else
		{
		cnt=0;
		}


	if ( cnt > 30 )
		{
		cSREG = SREG;		// Zapamitanie znacznika IRQ
		cli();
//TODO:
//zapis eeprom
		eeprom_write_block (&TabServ, &EETabServ, sizeof(EETabServ));
	//  eeprom_write_block (const void *__src, void *__dst, size_t __n);

		while ( 1 )			// Czekanie na zdjcie zworki
			{
			EorLedST();
			wdt_reset();_delay_ms(100);
			wdt_reset();_delay_ms(100);
			wdt_reset();_delay_ms(100);
			wdt_reset();_delay_ms(100);
			if ( RdPinDmx() ) break;
			}
		SREG = cSREG;		// Odtworzenie znacznika IRQ
		cnt=0;
		}


	DdrLedDmxO();				// Por wyjciem
	if ( !stan ) { SetLedDmx(); } else { ClrLedDmx(); }		// Odtworzenie stanu diody
#endif
}


//-------------------------------------------------------------------------
//					Init timer 0
//-------------------------------------------------------------------------
void InitTimer0()
{
/*
	#if F_CPU == 8000000
		TCCR0B = CNT0_PRESCALER_8;			// Preskaler na 8 (liczymy us)
	#elif F_CPU == 16000000
		TCCR0B = CNT0_PRESCALER_8;			// Preskaler na 8 (liczymy 500ns)
	#elif F_CPU == 20000000
		TCCR0B = CNT0_PRESCALER_64;			// Preskaler na 64 (liczymy 3,2us)
	#else
		#error "Nieznane F_CPU"
	#endif
*/
	TCNT0 = 0;
	TCCR0A = 0x0;
	TCCR0B = 5;
	TIMSK0 |= (1<<TOIE0);					// Zezwolenie na IRQ od przepelnienia timera
}


//----------------------------------------------------------------------//
//					Obsuga IRQ od timera 0
//----------------------------------------------------------------------//
INTERRUPT( TIMER0_OVF_vect )				// Mozliwe przerwanie wielopoziomowe (pierwsza instrukcja SEI)
{
	TCNT0_HH ++;



	if ( TCNT0_HH > (F_CPU/1024/256) * MIN_DMX_OFLINE )	// Brak transmisji ponad zadany czas
		{									// to
		DmxStatus = DMX_OFFLINE;
		#if DEVICE==DMXDIMMER
		 if ( RdCfg0()==0 ) ClrPK();		// gdy CFG0=ON wylacz PK
		#endif
		if ( RdCfg0()==0 && RdCfg2() )		// gdy CFG0=ON i CFG2=OFF wygas wyjscie
			{
			#if DEVICE==DMXDIMMER
			 RejestrPWM = 0;
			#elif DEVICE==DMXRGB || DEVICE==DEMUX
			 PWMGREEN = 0;
			 PWMRED = 0;
			 PWMBLUE = 0;
			 #if DEVICE==DEMUX
			  OCR2A= 0;
			 #endif
			#elif DEVICE==SERVO
			 eeprom_read_block (&TabServ, &EETabServ, sizeof(TabServ) );	// Odczyt eeprom
		   //eeprom_read_block (void *__dst, const void *__src, size_t __n);
//			 TabServ[0] = TabServ[1] = TabServ[2] = TabServ[3] = 128;
			#endif
			}
		}


}


//-------------------------------------------------------------------------
//					Init timer 1
//-------------------------------------------------------------------------
void InitTimer1()
{



#if DEVICE==DMXDIMMER
 #if F_CPU == 8000000
	TCCR1B = ( CNT1_PRESCALER_256 );	// Preskaler na 256
										// F = 8000000/256 = 31,250kHz
										// t = 32us
										// 10ms / 32us = 312
 #else
  #error "Zle F_CPU"
 #endif
//	TIMSK1 |= (1<<OCIE1A) | (1<<OCIE1B);// Zezwolenie na IRQ od porownania
	TIMSK1 |= (1<<TOIE1);				// Zezwolenie na IRQ od przepelnienia timera
#elif DEVICE==SERVO
 #if F_CPU == 16000000
	TCCR1B = ( CNT1_PRESCALER_64 );		// Preskaler na 256
										// F = 16000000/64 = 250kHz
										// t = 4us
	TCNT1 = 0xFFFF - 2;
	TIMSK1 |= (1<<TOIE1);				// Zezwolenie na IRQ od przepelnienia timera
 #else
  #error "Zle F_CPU"
 #endif
#elif DEVICE==DMXRGB
	TCCR1B = ( CNT1_PRESCALER_64 ) /*| ( 1<<WGM12 )*/ ;	// Preskaler na 64, PWM okoo 500Hz
	TCCR1A = (2<<COM1A0) | (2<<COM1B0) | ( 1<<WGM10 );	// PWM, Phase Correct, 8-bit
#elif DEVICE==DEMUX
	TCCR1B = ( CNT1_PRESCALER_8 ) /*| ( 1<<WGM12 )*/ ;	// Preskaler na 8
	TCCR1A = (2<<COM1A0) | (2<<COM1B0) | ( 1<<WGM10 );	// PWM, Phase Correct, 8-bit
#endif

}


//----------------------------------------------------------------------//
//					Obsuga IRQ od timera 1 - PWM dla triaka
//----------------------------------------------------------------------//
//SIGNAL( TIMER1_OVF_vect )				// NIE MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
INTERRUPT( TIMER1_OVF_vect )			// MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
{
#if DEVICE==DMXDIMMER
	 if ( RejestrPWMirq==255 )			// 255 bo rejestr zanegowany
		{
		ClrPWM();						// Wyjscie calkowicie wylaczone
		return;
		}
	#if F_CPU == 8000000
	 switch( fazaPWM )
		{
		case( SIN_H_TRIAK_OFF ):
			SetPWM();					// Triak aktywny
			TCNT1 = -2;
			fazaPWM = SIN_H_TRIAK_ON;
			break;
		case( SIN_H_TRIAK_ON ):
			ClrPWM();					// Triak niekatywny
			fazaPWM = SIN_L_TRIAK_OFF;
			break;
		}
/*	switch( fazaPWM )
		{
		case( SIN_H_TRIAK_OFF ):
			SetPWM();					// Triak aktywny
			TCNT1 = - (Czas50Hz - RejestrPWMirq);
			fazaPWM = SIN_H_TRIAK_ON;
			break;
		case( SIN_H_TRIAK_ON ):
			ClrPWM();					// Triak niekatywny
			TCNT1 = - ( RejestrPWMirq );// Start timera
			fazaPWM = SIN_L_TRIAK_OFF;
			break;
		case( SIN_L_TRIAK_OFF ):
			SetPWM();					// Triak aktywny
			TCNT1 = - ( Czas50Hz - RejestrPWMirq );
			fazaPWM = SIN_L_TRIAK_ON;
			break;
		case( SIN_L_TRIAK_ON ):
			ClrPWM();					// Triak niekatywny
			TCNT1 = - ( RejestrPWMirq );// Start timera
			fazaPWM = SIN_H_TRIAK_OFF;
			break;
		}
*/
	#else
	 #error "Zle F_CPU"
	#endif
#elif DEVICE==SERVO
static byte servo=0;


	TCNT1 = 0xFFFF - ( TabServ[servo] + (1000/4) );		// Ustawiamy timer na czas w 4 * us, co da zakres:
	switch( servo )										// ( 1000us / 4 +   0 ) * 4 = 1,000ms
		{												// ( 1000us / 4 + 128 ) * 4 = 1,512ms
		//												// ( 1000us / 4 + 256 ) * 4 = 2,024ms
		case( 0 ): SetS1(); break;						// Ustawiamy Serwo1
		case( 1 ): ClrS1(); SetS2(); break;				// Ustawiamy Serwo2, kasujemy 1
		case( 2 ): ClrS2(); SetS3(); break;				// Ustawiamy Serwo3, kasujemy 2
		case( 3 ): ClrS3(); SetS4(); break;				// Ustawiamy Serwo4, kasujemy 3
		case( 4 ): ClrS4();								// Kasujemy serwo
			TCNT1 = 0xFFFF - (20000 / 4);				// ustawiamy Sync 20ms
			break;
		}
	servo++; if ( servo > 4 ) servo = 0;

#endif
}


//----------------------------------------------------------------------//
//					Obsuga IRQ od porownania comparatora A				//
//----------------------------------------------------------------------//
INTERRUPT( TIMER1_COMPA_vect )			// MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
{

}


//----------------------------------------------------------------------//
//					Obsuga IRQ od porownania comparatora B				//
//----------------------------------------------------------------------//
INTERRUPT( TIMER1_COMPB_vect )			// MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
{

}


//----------------------------------------------------------------------//
#if DEVICE==DMXDIMMER
inline void SetNewValuePwm( byte input )
{
//	RejestrPWMirq = TabPWM[ 255-RejestrPWM ] << 1;
	RejestrPWMirq = ~RejestrPWM;
	#if F_CPU == 8000000
	 TCNT1 = - ( RejestrPWMirq+25 );					// Start timera (odcinek z wylaczonym triakiem)
	#else
		#error "Nieznane F_CPU"
	#endif

	fazaPWM = SIN_H_TRIAK_OFF;
}
#endif


//-------------------------------------------------------------------------
//					Init timer 2
//-------------------------------------------------------------------------
void InitTimer2()
{
#if DEVICE==DMXDIMMER
	TCCR2B = CNT0_PRESCALER_8;				// Preskaler na 8 (liczymy us)
#elif DEVICE==DMXRGB
	TCCR2B = CNT2_PRESCALER_64;				// Preskaler na 64, PWM okoo 500Hz
	TCCR2A = (2<<COM1B0) | ( 1<<WGM20 );	// PWM, Phase Correct, 8-bit
#elif DEVICE==DEMUX
	TCCR2B = CNT2_PRESCALER_8;							// Preskaler na 8
	TCCR2A = (2<<COM1A0) | (2<<COM1B0) | ( 1<<WGM20 );	// PWM, Phase Correct, 8-bit
#endif
}


//----------------------------------------------------------------------//
//					Obsuga IRQ od timera 2
//----------------------------------------------------------------------//
INTERRUPT( TIMER2_OVF_vect )			// Mozliwe przerwanie wielopoziomowe (pierwsza instrukcja SEI)
{
//	TCNT2_HH += 0x100;					// Zwiekszamy o 256
}


//--------------------------------------------------------------------------
//					Inicjalizacja INT 0
//--------------------------------------------------------------------------
void InitInt0()
{
	 EIMSK  |= (1<<INT0);				// INT0   - Zezwolenie na IRQ od wejscia INT0
	 EICRA  |= (1<<ISC00);				// INT0   - Kazde zbocze na INT0 wywouje IRQ
//	 EICRA  |= (2<<ISC00);				// INT0   - Zbocze narastajace na INT0 wywouje IRQ
}


//----------------------------------------------------------------------//
//					Obsuga IRQ od wejcia INT 0						//
//----------------------------------------------------------------------//
SIGNAL( INT0_vect )						// NIE MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
{
#if DEVICE==DMXDIMMER
	SetNewValuePwm( RdInInt0() );
#endif
}



//--------------------------------------------------------------------------
//					Inicjalizacja INT 1
//--------------------------------------------------------------------------
void InitInt1()
{
	 EIMSK  |= (1<<INT1);				// INT1   - Zezwolenie na IRQ od wejscia INT1
	 EICRA  |= (1<<ISC10);				// INT1   - Kazde zbocze na INT1 wywouje IRQ
//	 EICRA  |= (2<<ISC10);				// INT1   - Zbocze narastajace na INT1 wywouje IRQ
}


//----------------------------------------------------------------------//
//					Obsuga IRQ od wejcia INT 1						//
//----------------------------------------------------------------------//
//SIGNAL( INT1_vect )					// NIE MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
INTERRUPT( INT1_vect )					// Mozliwe przerwanie wielopoziomowe (pierwsza instrukcja SEI)
{
#if DEVICE==DMXDIMMER
	SetNewValuePwm( RdInInt1() );
#endif
}



//------------------------------------------------------------------------------
//					Inicjalizacja USART-a
//------------------------------------------------------------------------------
void InitUart()
{
//	UBRR0H = UBRRH_VALUE;
//	UBRR0L = UBRRL_VALUE;


#if F_CPU == 16000000
	UBRR0H = 0;
	UBRR0L = 3;			// Dla 16MHz
	UCSR0A = 0;
#elif F_CPU == 8000000
	UBRR0H = 0;			// Dla 8MHz
	UBRR0L = 1;			// Tablica 19-11 str 196
	UCSR0A = 0;
//	UBRR0L = 3;			// Tablica 19-11 str 196
//	UCSR0A = (1<<U2X0);
#else
 #error "Nieznane F_CPU"
#endif
	UCSR0B = (1<<RXEN0) | (1<<RXCIE0);						// Enable Reciver, Enable IRQ
	UCSR0C = (1<<USBS0) | (3<<UCSZ00);						// Set frame format: 8data, 2stop bit
}


//----------------------------------------------------------------------//
//					Obsluga IRQ od odbiornika USART-a
//------------------------------------------------------------------------------
//#define USART_RX_vect     _VECTOR(18)  /* USART Rx Complete */
//#define USART_UDRE_vect   _VECTOR(19)  /* USART, Data Register Empty */
//
//INTERRUPT( USART_RX_vect )		// Mozliwe przerwanie wielopoziomowe
SIGNAL( USART_RX_vect )				// Nie mozliwe przerwanie wielopoziomowe
{
byte static last_danaR=0;
#if DEVICE==DMXRGB || DEVICE==SERVO || DEVICE==DEMUX
 byte static last_danaG=0, last_danaB=0, last_danaW=0;
 byte static memDanaR=0, memDanaG=0, memDanaB=0, memDanaW=0;
#endif

#ifdef LEDSTTEST
 SetLedST();		// Pomiar czasu
#endif

	UsartStatus = UCSR0A;
	UsartDana = UDR0;
	UCSR0A = 0;


	if ( (UsartStatus & (1<<FE0)) )	// Jesli wykryto blad ramki to skonczyl sie sygnal BREAK
		{
		DmxStatus = DMX_BREAK;		// Ustaw status
		CntDanych = 0;				// Zeruj licznik danych
		#ifndef LEDSTTEST
		 EorLedST();
		#endif
		}
	else if(DmxStatus == DMX_BREAK)	// Jesli byl BREAK a pojawila sie nowa dana:
		{
		if ( CntDanych>512 ) { DmxStatus=DMX_OFFLINE; return; }	// Jesli za duzo danych
		if ( CntDanych==AdrDMX )								// Jesli nr danej zgadza sie z adresem
			{
			if ( RdCfg1()==0 ){ last_danaR = UsartDana; }		// Jesli niema zworki to musza byc dwa takie same odczyty
			if ( last_danaR == UsartDana )						// Jesli dwie odebrane dane sa identyczne
				{
				if ( memDanaR != UsartDana )					// Wpis do PWM tylko gdy bya zmiana
				 	{
					memDanaR = UsartDana;
					}
					#if DEVICE==DMXDIMMER
					 if ( UsartDana >= 128+HISTEREZAPK ) SetPK();
					 if ( UsartDana <= 128-HISTEREZAPK ) ClrPK();
					 RejestrPWM = UsartDana;					// Sterowanie jasnoscia
					#elif DEVICE==DMXRGB
			//		PWMRED = UsartDana;							// Sterowanie jasnoscia R
			//	 	 PWMRED = gamma32_correction[ UsartDana >> 3 ];// Sterowanie jasnoscia R
				 	 PWMRED = pgm_read_byte(&gamma256_correction[ UsartDana ]);	// Sterowanie jasnoscia R
					#elif DEVICE==DEMUX
				 	 OCR1A = UsartDana;
					#elif DEVICE==SERVO
					 TabServ[ 0 ] = UsartDana;
					#endif
				TCNT0 = TCNT0_HH = 0;							// liczymy timeout
				}
			last_danaR = UsartDana;
			}
		else if ( CntDanych==AdrDMX+1 )							// Jesli nr danej zgadza sie z adresem
			{
			if ( RdCfg1()==0 ){ last_danaG = UsartDana; }		// Jesli niema zworki to musza byc dwa takie same odczyty
			if ( last_danaG == UsartDana )						// Jesli dwie odebrane dane sa identyczne
				{
				if ( memDanaG != UsartDana )					// Wpis do PWM tylko gdy bya zmiana
				 	{
					memDanaG = UsartDana;
					#if DEVICE==DMXRGB
			//		 PWMGREEN = UsartDana;						// Sterowanie jasnoscia G
			//		 PWMGREEN = gamma32_correction[ UsartDana >> 3 ];// Sterowanie jasnoscia G
					 PWMGREEN = pgm_read_byte(&gamma256_correction[ UsartDana ]);// Sterowanie jasnoscia G
					#elif DEVICE==DEMUX
				 	 OCR1B = UsartDana;
					#elif DEVICE==SERVO
					 TabServ[ 1 ] = UsartDana;
					#endif
					}
				}
			last_danaG = UsartDana;
			}
		else if ( CntDanych==AdrDMX+2 )							// Jesli nr danej zgadza sie z adresem
			{
			if ( RdCfg1()==0 ){ last_danaB = UsartDana; }		// Jesli niema zworki to musza byc dwa takie same odczyty
			if ( last_danaB == UsartDana )						// Jesli dwie odebrane dane sa identyczne
				{
				if ( memDanaB != UsartDana )					// Wpis do PWM tylko gdy bya zmiana
				 	{
					memDanaB = UsartDana;
					#if DEVICE==DMXRGB
		//			 PWMBLUE = UsartDana;						// Sterowanie jasnoscia B
		//			 PWMBLUE = gamma32_correction[ UsartDana >> 3 ];// Sterowanie jasnoscia B
					 PWMBLUE = pgm_read_byte(&gamma256_correction[ UsartDana ]);// Sterowanie jasnoscia B
					#elif DEVICE==DEMUX
				 	 OCR2A = UsartDana;
					#elif DEVICE==SERVO
					 TabServ[ 2 ] = UsartDana;
					#endif
					}
				}
			last_danaB = UsartDana;
			}
		else if ( CntDanych==AdrDMX+3 )							// Jesli nr danej zgadza sie z adresem
			{
			if ( RdCfg1()==0 ){ last_danaW = UsartDana; }		// Jesli niema zworki to musza byc dwa takie same odczyty
			if ( last_danaW == UsartDana )						// Jesli dwie odebrane dane sa identyczne
				{
				if ( memDanaW != UsartDana )					// Wpis do PWM tylko gdy bya zmiana
				 	{
					memDanaW = UsartDana;
					#if DEVICE==DEMUX
					 OCR2B = UsartDana;
					#elif DEVICE==SERVO
					 TabServ[ 3 ] = UsartDana;
					#endif
					}
				}
			last_danaW = UsartDana;
			}
		CntDanych++;											// nastepny kanal
		}

#ifdef LEDSTTEST
 ClrLedST();		// Pomiar czasu
#endif
}


//----------------------------------------------------------------------//
word ReadAdrDMX()
{
word adr=0;


	if ( RdA0()==0 ) adr |= (1<<0);
	if ( RdA1()==0 ) adr |= (1<<1);
	if ( RdA2()==0 ) adr |= (1<<2);
	if ( RdA3()==0 ) adr |= (1<<3);
	if ( RdA4()==0 ) adr |= (1<<4);
	if ( RdA5()==0 ) adr |= (1<<5);
	if ( RdA6()==0 ) adr |= (1<<6);
	if ( RdA7()==0 ) adr |= (1<<7);
	if ( RdA8()==0 ) adr |= (1<<8);

	if (adr==0) adr=512;

	return( adr );
}


//----------------------------------------------------------------------//

